<template>
  <div class="new-consignee-or-consignor">
    <ObModal
      ref="modal"
      :title="`Новый г${contractorTypeWordRoot}ь`"
    >
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Добавить"
        :is-loading="isLoading"
        data-qa="newConsigneeOrConsignorForm"
        @submit="addContractor(formData)"
      >
        <ObInput
          v-model="formData.contractor"
          :label="`Г${contractorTypeWordRoot}ь`"
          :placeholder="`Введите г${contractorTypeWordRoot}я`"
          class="mb20"
        />
        <div
          v-if="error"
          class="error-block mb20"
        >
          <i class="icon alert"/>
          <span>Грузоотправитель с таким названием уже зарегистрирован</span>
        </div>
        <ObInput
          v-model="formData.inn"
          label="ИНН"
          placeholder="Введите ИНН"
          class="mb20"
        />
      </ObForm>
    </ObModal>
  </div>
</template>

<script>
import ObModal from 'common-components/src/obComponents/obModal'
import ObInput from 'common-components/src/obComponents/obInput'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'
import { uuid } from 'vue-uuid'

export default {
  name: 'NewConsigneeOrConsignor',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObModal,
    ObInput
  },
  props: {
    cargoOwnerUuid: {
      type: String,
      required: true
    },
    isConsignee: {
      type: Boolean,
      required: true
    },
    isConsignor: {
      type: Boolean,
      required: true
    }
  },
  data () {
    return {
      isLoading: false,
      error: false
    }
  },
  computed: {
    contractorTypeWordRoot () {
      return this.isConsignor ? 'рузоотправител' : 'рузополучател'
    },
    formModel () {
      return {
        ownerUuid: {
          value: () => this.cargoOwnerUuid,
          validator: {
            required
          }
        },
        contractor: {
          value: '',
          validator: {
            required
          }
        },
        isConsignee: {
          type: 'boolean',
          value: () => this.isConsignee,
          validator: {
            required
          }
        },
        isConsignor: {
          type: 'boolean',
          value: () => this.isConsignor,
          validator: {
            required
          }
        },
        inn: {
          value: '',
          validator: {
            required
          }
        }
      }
    }
  },
  methods: {
    open () {
      this.$refs.modal.open()
    },
    close () {
      this.$refs.modal.close()
    },
    async addContractor (data) {
      try {
        this.isLoading = true
        data.contractorUuid = uuid.v4()
        await api.orderProcess.createConsignorsConsignees(data)
        this.isLoading = false
        this.$emit('submitted', data)
        this.close()
      } catch (e) {
        this.isLoading = false
        this.error = true
      }
    },
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";
  .mb20 {
    margin-bottom: 20px!important;
  }
  .error-block {

  }
</style>
